# remirepo/Fedora spec file for php-zendframework-zend-expressive-zendrouter
#
# Copyright (c) 2016-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    89a18a82fff3c374d347f29b33411ca6a48a90c4
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-expressive-zendrouter
%global php_home     %{_datadir}/php
%global library      Expressive
%global sublib       Router
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.0.1
Release:        6%{?dist}
Summary:        zend-mvc router support for %{library}

License:        BSD
URL:            https://framework.zend.com/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-composer(psr/http-message)                       >= 1.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-expressive-router)   >= 2.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-router)              >= 3.0
BuildRequires:  php-composer(%{gh_owner}/zend-psr7bridge)            >= 0.2.2
BuildRequires:  php-composer(fig/http-message-util)                  >= 1.1
BuildRequires:  php-pcre
# From composer, "require-dev": {
#        "phpunit/phpunit": "^4.8 || ^5.6",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "malukenho/docheader": "^0.1.5",
#        "zendframework/zend-i18n": "^2.7"
BuildRequires:  php-composer(phpunit/phpunit)                        >= 4.8
BuildRequires:  php-autoloader(%{gh_owner}/zend-i18n)                >= 2.7
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "psr/http-message": "^1.0",
#        "zendframework/zend-expressive-router": "^2.0",
#        "zendframework/zend-router": "^3.0",
#        "zendframework/zend-psr7bridge": "^0.2.2",
#        "fig/http-message-util": "^1.1"
Requires:       php(language) >= 5.6
Requires:       php-composer(psr/http-message)                       >= 1.0
Requires:       php-composer(psr/http-message)                       <  2
Requires:       php-autoloader(%{gh_owner}/zend-expressive-router)   >= 2.0
Requires:       php-autoloader(%{gh_owner}/zend-expressive-router)   <  3
Requires:       php-autoloader(%{gh_owner}/zend-router)              >= 3.0
Requires:       php-autoloader(%{gh_owner}/zend-router)              <  4
Requires:       php-autoloader(%{gh_owner}/zend-psr7bridge)          >= 0.2.2
Requires:       php-composer(fig/http-message-util)                  >= 1.1
Requires:       php-composer(fig/http-message-util)                  <  2
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.2.0
Requires:       php-pcre

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Provides ZF2's MVC router integration for zend-expressive.

Documentation: 
https://zendframework.github.io/zend-expressive/features/router/zf2/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create dependency autoloader - deprecated
cat << 'EOF' | tee autoload.php
<?php
require_once '%{php_home}/Fig/Http/Message/autoload.php';
EOF

: Create autoloader
phpab --template fedora --output src/zendrouter-autoload.php src
cat << 'EOF' | tee -a src/zendrouter-autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Psr/Http/Message/autoload.php',
    '%{php_home}/Zend/Expressive/Router/autoload.php',
    '%{php_home}/Zend/Router/autoload.php',
    '%{php_home}/Zend/Psr7Bridge/autoload.php',
    '%{php_home}/Fig/Http/Message/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/%{library}
cp -pr src %{buildroot}%{php_home}/Zend/%{library}/%{sublib}

install -m644 autoload.php %{buildroot}%{php_home}/Zend/%{library}-%{sublib}-zendrouter-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/%{sublib}/zendrouter-autoload.php';
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/I18n/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\%{sublib}', dirname(__DIR__) . '/test');
EOF

ret=0
for cmd in php php56 php70 php71 php72; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}/%{sublib}/ZendRouter*
%{php_home}/Zend/%{library}/%{sublib}/zendrouter*
%{php_home}/Zend/%{library}-%{sublib}-zendrouter-autoload.php


%changelog
* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.1-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Dec 11 2017 Remi Collet <remi@remirepo.net> - 2.0.1-3
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Thu Mar  2 2017 Remi Collet <remi@fedoraproject.org> - 2.0.1-1
- update to 2.0.1

* Tue Feb 14 2017 Remi Collet <remi@fedoraproject.org> - 2.0.0-1
- update to 2.0.0
- raise dependency on zend-expressive-router 2.0

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Dec 15 2016 Remi Collet <remi@fedoraproject.org> - 1.3.0-1
- update to 1.3.0
- raise dependency on zendframework/zend-expressive-router 1.3.2
- add dependency on fig/http-message-util

* Fri Aug 12 2016 Remi Collet <remi@fedoraproject.org> - 1.2.0-1
- update to 1.2.0

* Sat Jul  2 2016 Remi Collet <remi@fedoraproject.org> - 1.1.0-2
- cleanup and build for ZF2

* Fri Jul  1 2016 Remi Collet <remi@fedoraproject.org> - 1.1.0-1
- initial package

